#include <iostream>
#include <cmath>
#include <vector>
#include <algorithm>
#include <set>
using namespace std;

int n;
set< pair<int,int> > d;
vector<bool> used;
vector<set<int> > way;

void dfs(int a){
    used[a]=true;
    int k=way.size();
    if (k && a) way[k-1].insert(a);
    for (int i=0;i<n;i++){
        pair<int,int> p1={a,i};
        if ((!used[i])&&(d.count(p1)>0)){
            if (a==0){
                set<int> f;
                f.insert(0);
                way.push_back(f);
                dfs(i);
            }
            else{
                dfs(i);
            }
        }
    }
}

using namespace std;
int main(){
    int m;
    long long rez=0;
    cin >> n >> m;
    used.push_back(false);
    for (int i=0;i<n-1;i++){
        int x;
        cin >> x;
        pair<int,int> p={x-1,i+1};
        d.insert(p);
        used.push_back(false);
    }
    dfs(0);
    sort(way.begin(),way.end());
    int h=way.size(),l=way[0].size();
    if (way.size()>1){
        int k=way[1].size();
        rez=m*l+(m-1)*l+k-1;
    }
    else rez=m*l;
    cout << rez;
}
